MusicPlayerOptions = { };

function MusicPlayer_Button_Initialize()
	if(event == "VARIABLES_LOADED") then
		if (MusicPlayerOptions.MusicPlayerButtonPosition == nil) then
			MusicPlayerOptions.MusicPlayerButtonPosition = 25;
		end
	end
end

function MusicPlayer_DropDown_Initialize()
	local dropdown;
	if ( UIDROPDOWNMENU_OPEN_MENU ) then
		dropdown = getglobal(UIDROPDOWNMENU_OPEN_MENU);
	else
		dropdown = this;
	end
	MusicPlayer_DropDown_InitButtons();
end


function MusicPlayer_DropDown_OnLoad()
	UIDropDownMenu_Initialize(this, MusicPlayer_DropDown_Initialize, "MENU");
end

function MusicPlayer_Button_BeingDragged()
    local xpos,ypos = GetCursorPosition();
    local xmin,ymin = Minimap:GetLeft(), Minimap:GetBottom();
    xpos = xmin-xpos/UIParent:GetScale()+70;
    ypos = ypos/UIParent:GetScale()-ymin-70;
    MusicPlayer_Button_SetPosition(math.deg(math.atan2(ypos,xpos)));
end

function MusicPlayer_Button_OnClick(arg)
	if (arg == "LeftButton") then
		MusicPlayer_ToggleDropDown();
	end
end



function MusicPlayer_Button_OnEnter()
	GameTooltip:SetOwner(this, "ANCHOR_LEFT");
	GameTooltip:SetText(MusicPlayer_BUTTON_TOOLTIP0);
	GameTooltip:AddLine(MusicPlayer_BUTTON_TOOLTIP1);
	GameTooltip:AddLine(MusicPlayer_BUTTON_TOOLTIP2);
	GameTooltip:Show();
end

function MusicPlayer_Button_SetPosition(v)
    if(v < 0) then
        v = v + 360;
    end
    MusicPlayerOptions.MusicPlayerButtonPosition = v;
    MusicPlayer_Button_UpdatePosition();
end

function MusicPlayer_Button_UpdatePosition()
	MusicPlayer_ButtonFrame:SetPoint(
		"TOPLEFT",
		"Minimap",
		"TOPLEFT",
		54 - (78 * cos(MusicPlayerOptions.MusicPlayerButtonPosition)),
		(78 * sin(MusicPlayerOptions.MusicPlayerButtonPosition)) - 55
	);
end

function MusicPlayer_ToggleDropDown()
	UIDropDownMenu_Initialize(MusicPlayer_DropDownFrame, MusicPlayer_DropDown_Initialize, "MENU");
	MusicPlayer_DropDownFrame.Point = "TOP"
	MusicPlayer_DropDownFrame.relativeTo = "MusicPlayer_Button"
	MusicPlayer_DropDownFrame.relativePoint = "BOTTOM"
	ToggleDropDownMenu(1, nil, MusicPlayer_DropDownFrame);
end


function ToggleMPButton()
	if ( MusicPlayerOptions.MPButton == false ) then
		getglobal('MusicPlayer_Button'):Show();
		MusicPlayerOptions.MPButton = true
	else
		getglobal('MusicPlayer_Button'):Hide();
		MusicPlayerOptions.MPButton = false
	end
	MPButtonPrint();
end

function MusicPlayer_DropDown_InitButtons()
	local info = {};
	info.text = MusicPlayer_LABEL_TITLE2;
	info.isTitle = 2;
	info.justifyH = "CENTER";
	info.notCheckable = 1;
	UIDropDownMenu_AddButton(info);
		MusicPlayer_DropDownMusicControl();
end


function MusicPlayer_DropDownMusicControl()
	local appender = ': ';

	local info = { };
	info.text = MusicPlayer_FadeSong;
	info.isTitle = nil;
	info.justifyH = "CENTER";
	info.notCheckable = 1;
	info.func = function(msg) MusicPlayerStop(); end;
	UIDropDownMenu_AddButton(info);

	local info = { };
	info.text = MusicPlayer_Next_Song;
	info.isTitle = nil;
	info.justifyH = "CENTER";
	info.notCheckable = 1;
	info.func = function(msg) MusicPlayer_PlayNextSong(); end;
	UIDropDownMenu_AddButton(info);

	local info = { };
	info.text = MusicPlayer_Previous_Song;
	info.isTitle = nil;
	info.justifyH = "CENTER";
	info.notCheckable = 1;
	info.func = function(msg) MusicPlayer_PlayPrevSong(); end;
	UIDropDownMenu_AddButton(info);

	local info = {};
	info.text = MusicPlayer_LABEL_TITLE3;
	info.isTitle = 2;
	info.justifyH = "CENTER";
	info.notCheckable = 1;
	UIDropDownMenu_AddButton(info);
		MusicPlayer_DropDownOptionsLink();
end



function MusicPlayer_DropDownOptionsLink()
	local appender = ': ';

	local info = { };
	info.text = MUSICPLAYER_OPTIONS_OPTIONS;
	info.isTitle = nil;
	info.justifyH = "CENTER";
	info.notCheckable = 1;
	info.func = function(msg)
		MP_ToggleOptions();
	end;
	UIDropDownMenu_AddButton(info);

	local info = { };
	if (MusicPlayerHelpFrame:IsVisible()) then
		info.text = MUSICPLAYER_THX;
	else
		info.text = MUSICPLAYER_HELP;
	end
	info.isTitle = nil;
	info.justifyH = "CENTER";
	info.notCheckable = 1;
	info.func = function(msg)
		MP_ToggleHelp();
	end;
	UIDropDownMenu_AddButton(info);

	local info = { };
	info.text = MUSICPLAYER_SONGS;
	info.isTitle = nil;
	info.justifyH = "CENTER";
	info.notCheckable = 1;
	info.func = function(msg)
		if (MusicPlayer_RenameFrame:IsVisible()) then
			MusicPlayer_RenameFrame:Hide();
		else
			MusicPlayer_RenameFrame:Show();
		end
	end;
	UIDropDownMenu_AddButton(info);

	if(MusicPlayerFrameOptions.PlayWhenFinished == 1)then
		local info = { };
		info.text = MusicPlayer_LABEL_TITLE4;
		info.isTitle = 2;
		info.justifyH = "CENTER";
		info.notCheckable = 1;
		UIDropDownMenu_AddButton(info);

		local info = { };
		if (MusicPlayerFrameOptions.WhenFinished == 11) then
			info.text = MUSICPLAYER_PLAYNEXT;
		elseif (MusicPlayerFrameOptions.WhenFinished == 12) then
			info.text = MUSICPLAYER_RANDOM;
		elseif (MusicPlayerFrameOptions.WhenFinished == 13) then
			info.text = MUSICPLAYER_LOOP;
		end
		info.isTitle = nil;
		info.justifyH = "CENTER";
		info.notCheckable = 1;
		info.func = function(msg)
			if (MusicPlayerFrameOptions.WhenFinished == 11) then
				MusicPlayerFrameOptions.WhenFinished = 12;
				info.text = MUSICPLAYER_RANDOM;
			elseif (MusicPlayerFrameOptions.WhenFinished == 12) then
				MusicPlayerFrameOptions.WhenFinished = 13;
				info.text = MUSICPLAYER_LOOP;
			elseif (MusicPlayerFrameOptions.WhenFinished == 13) then
				MusicPlayerFrameOptions.WhenFinished = 11;
				info.text = MUSICPLAYER_PLAYNEXT;
			end
			MP_WhenFinished = MusicPlayerFrameOptions.WhenFinished;
			UIDropDownMenu_SetSelectedValue(MusicPlayerOptionsFrame_WhenFinished_DropDown, MusicPlayerFrameOptions.WhenFinished);
		end;
		UIDropDownMenu_AddButton(info);
	end

end
